﻿using System;

namespace Consola.Dominio
{
    public class Persona : Object, IComparable
    {
        public string Nombres { get; set; }

        public string Apellidos { get; set; }

        public Cedula Cedula { get; set; }

        public Dpi Dpi { get; set; }

        public DateTime FechaDeNacimiento { get; set; }
        
        public Persona()
        {
            Nombres = "";
            Apellidos = "";
        }

        public Persona(string nombres)
        {
            Nombres = nombres;
            Apellidos = "";
        }

        public Persona(string nombres, string apellidos)
        {
            Nombres = nombres;
            Apellidos = apellidos;
        }

        public Persona(Cedula cedula)
        {
            Nombres = "adsf";
            Apellidos = "";
            Cedula = cedula;
        }

        public bool EsValida()
        {
            if (Nombres == null || Nombres.Length == 0)
            {
                return false;
            }
            if (Apellidos == null || Apellidos.Length == 0)
            {
                return false;
            }
            return true;
        }

        public bool EsValida(bool validarNombre)
        {
            if (validarNombre)
            {
                if (Nombres == null || Nombres.Length == 0)
                {
                    return false;
                }
            }
            if (Apellidos == null || Apellidos.Length == 0)
            {
                return false;
            }
            return true;
        }

        public override string ToString()
        {
            return Nombres + " " + Apellidos;
        }

        public TimeSpan ObtenerEdad()
        {
            return DateTime.Today - FechaDeNacimiento;
        }

        public virtual string ObtenerNombreCompleto()
        {
            return Nombres + " " + Apellidos;
        }


        public int CompareTo(object obj)
        {
            var otraPersona = obj as Persona;
            if (otraPersona == null)
            {
                return 1;
            }
            return this.Nombres.CompareTo(otraPersona.Nombres);
        }
    }
}